SystemOrganization addCategory: #MEG!
SystemOrganization addCategory: 'MEG-Model'!
SystemOrganization addCategory: 'MEG-Tests-Integration-Interaction'!
SystemOrganization addCategory: 'MEG-Tests-Integration-Movie'!
SystemOrganization addCategory: 'MEG-Tests-Unit'!

TestCase subclass: #EruCreatesTheWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG-Tests-Integration-Movie'!

!EruCreatesTheWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:28'!
test_01_WorldCreation

	| world gandalf rivendel elrond spawn |
	world := MEGWorld new.
	rivendel := MEGSite named: 'Rivendel'.
	gandalf := MEGCharacter named: 'Gandalf' homeSiteType: 'Haven'.
	elrond := MEGCharacter named: 'Elrond' homeSiteNamed: 'Rivendel'.
	spawn := MEGRecruitCharacterAction new.
	
	world addSite: rivendel.
	world addCharacter: gandalf.
	world addCharacter: elrond.
	
! !

TestCase subclass: #HomeSiteCriteriaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG-Tests-Unit'!

!HomeSiteCriteriaTest commentStamp: '<historical>' prior: 0!
A HomeSiteCriteriaTest is a test class for testing the behavior of HomeSiteCriteria!

!HomeSiteCriteriaTest methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:26'!
test_01_CreationOfNamedCriteria

	| criteria |
	criteria := HomeSiteCriteria named: 'Rivendel'.
! !

!HomeSiteCriteriaTest methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:26'!
test_02_CreationOfTypeCriteria

	| criteria |
	criteria := HomeSiteCriteria type: 'Haven'.
! !

TestCase subclass: #MEGCharacterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG-Tests-Unit'!

!MEGCharacterTest commentStamp: '<historical>' prior: 0!
A MEGCharacterTest is a test class for testing the behavior of MEGCharacter!

!MEGCharacterTest methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:45'!
test_01_Defaults

	| character |
	character := MEGCharacter new.
	self assert: character name isNil.
	self assert: character homeSiteCriteria isNil.
	self assert: character companies isEmpty.! !

!MEGCharacterTest methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:35'!
test_02_CreationWithHomeSiteNamed
	| character |
	character := MEGCharacter named: 'Bilbo' homeSiteNamed: 'Bag Ends'.
	self assert: character name = 'Bilbo'.
	self assert: character homeSiteCriteria notNil.! !

!MEGCharacterTest methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:45'!
test_03_CreationWithHomeSiteType
	| character |
	character := MEGCharacter named: 'Bilbo' homeSiteType: 'Haven'.
	self assert: character name = 'Bilbo'.
	self assert: character homeSiteCriteria notNil.! !

TestCase subclass: #MEGSiteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG-Tests-Unit'!

!MEGSiteTest commentStamp: '<historical>' prior: 0!
A MEGSiteTest is a test class for testing the behavior of MEGSite!

!MEGSiteTest methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:30'!
test_01_Defaults

	| site |
	site := MEGSite new.
	self assert: site name isNil.! !

!MEGSiteTest methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:30'!
test_02_Creation

	| site |
	site := MEGSite named: 'Dol-Amroth'.
	self assert: site name = 'Dol-Amroth'.! !

TestCase subclass: #MEGWorldTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG-Tests-Unit'!

!MEGWorldTest commentStamp: '<historical>' prior: 0!
A MEGWorldTest is a test class for testing the behavior of MEGWorld!

!MEGWorldTest methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 08:31'!
test_01_Creation

	| world |
	world := MEGWorld new.
	self assert: world locations isEmpty.
	self assert: world characters isEmpty.! !

!MEGWorldTest methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:19'!
test_02_AddSite

	| world |
	world := MEGWorld new.
	world addSite: (MEGSite named: 'Lothlorien').
	self assert: world locations notEmpty.
	self assert: world locations size = 1.
! !

!MEGWorldTest methodsFor: 'public' stamp: 'FedericoFigueredo 5/27/2016 08:17'!
test_03_AddCharacter

	| world |
	world := MEGWorld new.
	world addCharacter: (MEGCharacter named: 'Frodo' homeSiteNamed: 'Bag End').
	self assert: world characters notEmpty.
	self assert: world characters size = 1.
! !

!MEGWorldTest methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:42'!
test_04_RetrieveSite

	| world  |
	world := MEGWorld new.
	self should: [world siteNamed: 'Rivendel'] raise: NotFound.
	world addSite: (MEGSite named: 'Rivendel').
	self assert: (world siteNamed: 'Rivendel') notNil.
! !

!MEGWorldTest methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:43'!
test_05_RetrieveCharacter

	| world  |
	world := MEGWorld new.
	self should: [world characterNamed: 'Eowyn'] raise: NotFound.
	world addCharacter: (MEGCharacter named: 'Eowyn' homeSiteNamed: 'Rohan').
	self assert: (world characterNamed: 'Eowyn') notNil.
! !

TestCase subclass: #TheCompanyFormsAtRivendel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG-Tests-Integration-Interaction'!

!TheCompanyFormsAtRivendel methodsFor: 'private' stamp: 'SergioFedi 5/26/2016 23:28'!
newWorld

	| world gandalf rivendel elrond spawn |
	world := MEGWorld new.
	rivendel := MEGSite named: 'Rivendel'.
	gandalf := MEGCharacter named: 'Gandalf' homeSiteType: 'Haven'.
	elrond := MEGCharacter named: 'Elrond' homeSiteNamed: 'Rivendel'.
	spawn := MEGRecruitCharacterAction new.
	
	world addSite: rivendel.
	world addCharacter: gandalf.
	world addCharacter: elrond.
	
	^world.! !

!TheCompanyFormsAtRivendel methodsFor: 'public' stamp: 'FedericoFigueredo 5/27/2016 09:29'!
test_01_GandalfRecruitsElrond

	| world rivendel gandalf elrond |
	world := self newWorld.
	rivendel := world siteNamed: 'Rivendel'.
	gandalf := world characterNamed: 'Gandalf'.
	elrond := world characterNamed: 'Elrond'.
	gandalf recruit: elrond at: rivendel.
	self assert: (elrond characterFollowed) = gandalf.
	self assert: (elrond currentSite) = rivendel.
	self assert: (gandalf followers includes: elrond).
	self assert: (rivendel occupants includes: elrond).! !

!TheCompanyFormsAtRivendel methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:28'!
test_01a_ElrondSpawnsAtRivendel

	| world rivendel gandalf elrond spawn |
	world := self newWorld.
	rivendel := world siteNamed: 'Rivendel'.
	gandalf := world characterNamed: 'Gandalf'.
	elrond := world characterNamed: 'Elrond'.
	spawn := MEGRecruitCharacterAction on: world.
	
	self deny: (rivendel includes: elrond).
	self assert: elrond location isNil.
	spawn 
		world: world;
		character: elrond;
		alliedTo: gandalf;
		
		perform.
	self assert: (rivendel includes: elrond).
	self assert: elrond location = rivendel.! !

!TheCompanyFormsAtRivendel methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:28'!
test_01b_ElrondSpawnsAtRivendel

	| world rivendel gandalf elrond spawn |
	world := self newWorld.
	rivendel := world siteNamed: 'Rivendel'.
	gandalf := world characterNamed: 'Gandalf'.
	elrond := world characterNamed: 'Elrond'.
	spawn := MEGRecruitCharacterAction on: world.
	
	self deny: (rivendel includes: elrond).
	self assert: elrond location isNil.
	spawn 
		world: world;
		character: elrond;
		alliedTo: gandalf;
		site: elrond homeSite;
		perform.
	self assert: (rivendel includes: elrond).
	self assert: elrond location = rivendel.! !

!TheCompanyFormsAtRivendel methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:28'!
test_01c_ElrondSpawnsAtRivendel

	| world rivendel gandalf elrond spawn |
	world := self newWorld.
	rivendel := world siteNamed: 'Rivendel'.
	gandalf := world characterNamed: 'Gandalf'.
	elrond := world characterNamed: 'Elrond'.
	spawn := MEGRecruitCharacterAction on: world.
	
	self deny: (rivendel includes: elrond).
	self assert: elrond location isNil.
	spawn 
		world: world;
		character: elrond;
		alliedTo: gandalf;
		site: rivendel;
		perform.
	self assert: (rivendel includes: elrond).
	self assert: elrond location = rivendel.! !

Object subclass: #HomeSiteCriteria
	instanceVariableNames: 'type name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG-Model'!

!HomeSiteCriteria class methodsFor: 'instance creation' stamp: 'FedericoFigueredo 5/27/2016 08:25'!
named: aString

 ^self new name: aString.! !

!HomeSiteCriteria class methodsFor: 'instance creation' stamp: 'SergioFedi 5/26/2016 09:03'!
type: aString

	^self new
		type: aString;
		yourself.! !

!HomeSiteCriteria methodsFor: 'private' stamp: 'SergioFedi 5/26/2016 09:11'!
name: aString

	name := aString.! !

!HomeSiteCriteria methodsFor: 'private' stamp: 'SergioFedi 5/26/2016 09:03'!
type: aString

	type := aString.! !

Object subclass: #MEGCharacter
	instanceVariableNames: 'name homeSiteCriteria companies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG-Model'!

!MEGCharacter class methodsFor: 'instance creation' stamp: 'SergioFedi 5/26/2016 09:08'!
named: aString homeSiteNamed: siteName

	^self new
		name: aString;
		homeSiteCriteria: (HomeSiteCriteria named: siteName);
		yourself.! !

!MEGCharacter class methodsFor: 'instance creation' stamp: 'SergioFedi 5/26/2016 09:02'!
named: aString homeSiteType: homeSiteTypeString

	^self new
		name: aString;
		homeSiteCriteria: (HomeSiteCriteria type: homeSiteTypeString);
		yourself.! !

!MEGCharacter methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:46'!
companies

	^companies.! !

!MEGCharacter methodsFor: 'private' stamp: 'SergioFedi 5/26/2016 08:55'!
homeSiteCriteria
	^ homeSiteCriteria! !

!MEGCharacter methodsFor: 'private' stamp: 'SergioFedi 5/26/2016 08:55'!
homeSiteCriteria: anObject
	homeSiteCriteria := anObject! !

!MEGCharacter methodsFor: 'initialization' stamp: 'SergioFedi 5/26/2016 23:46'!
initialize

	super initialize.

	companies := OrderedCollection new.
	homeSiteCriteria := nil.
	name := nil.! !

!MEGCharacter methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 08:56'!
name
	^ name! !

!MEGCharacter methodsFor: 'private' stamp: 'SergioFedi 5/26/2016 08:55'!
name: anObject
	name := anObject! !

Object subclass: #MEGRecruitCharacterAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG-Model'!

Object subclass: #MEGSite
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG-Model'!

!MEGSite class methodsFor: 'instance creation' stamp: 'SergioFedi 5/26/2016 08:51'!
named: aString

	^self new name: aString.! !

!MEGSite methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 08:51'!
name
	^ name! !

!MEGSite methodsFor: 'private' stamp: 'SergioFedi 5/26/2016 08:50'!
name: anObject
	name := anObject! !

Object subclass: #MEGWorld
	instanceVariableNames: 'locations characters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG-Model'!

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 09:12'!
addCharacter: aMEGCharacter

	characters add: aMEGCharacter.! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 09:11'!
addSite: aMEGSite

	locations add: aMEGSite.! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:44'!
characterNamed: aString

	^self characters detect: [:char | char name = aString].! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 08:32'!
characters
	^ characters! !

!MEGWorld methodsFor: 'initialization' stamp: 'SergioFedi 5/26/2016 08:32'!
initialize

	super initialize.

	characters := OrderedCollection new.
	locations := OrderedCollection new.! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 08:32'!
locations

	^locations.! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:40'!
siteNamed: aString

	^self locations detect: [:site | site name = aString].! !
